#pragma export on

#include "Leaf.h"

// --------------------------------------------------------------------------
// ------------ Leaf class, multiple inheritance version --------------------
// --------------------------------------------------------------------------

Leaf::Leaf(minimax size)
		: BView(BRect(0,0,1,1),"", 0,0)
{
	SetFlags(B_WILL_DRAW);
	mpm=size;
};

minimax Leaf::layoutprefs()
{
	return mpm;
}

BRect Leaf::layout(BRect rect)
{
	int cx,cy;

	cx=rect.Width()+1;
	cy=rect.Height()+1;
	if(cx > mpm.maxi.x) cx = mpm.maxi.x;
	if(cy > mpm.maxi.y) cy = mpm.maxi.y;
	
	ResizeTo(cx-1,cy-1);
	MoveTo(rect.LeftTop());
	rect=Bounds();
	Draw(rect);
	
	return rect;
}


// just a simple draw-function, so there's something to look at.
void Leaf::Draw(BRect a)
{
#pragma unused(a)
	BRect r;

	if(!CountChildren())
	{
		r=Bounds();
		FillRect(r,B_SOLID_LOW);
		StrokeLine(BPoint(r.left,r.bottom),BPoint(r.right,r.top),B_SOLID_HIGH);
		StrokeLine(BPoint(r.left,r.top),BPoint(r.right,r.bottom),B_SOLID_HIGH);
		StrokeRect(r);
	}
}
#pragma export off

